from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="UserTips")


@_attrs_define
class UserTips:
    """
    Attributes:
        stack (bool | Unset):
        document (bool | Unset):
        email (bool | Unset):
        unclassified (bool | Unset):
    """

    stack: bool | Unset = UNSET
    document: bool | Unset = UNSET
    email: bool | Unset = UNSET
    unclassified: bool | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        stack = self.stack

        document = self.document

        email = self.email

        unclassified = self.unclassified

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if stack is not UNSET:
            field_dict["stack"] = stack
        if document is not UNSET:
            field_dict["document"] = document
        if email is not UNSET:
            field_dict["email"] = email
        if unclassified is not UNSET:
            field_dict["unclassified"] = unclassified

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        stack = d.pop("stack", UNSET)

        document = d.pop("document", UNSET)

        email = d.pop("email", UNSET)

        unclassified = d.pop("unclassified", UNSET)

        user_tips = cls(
            stack=stack,
            document=document,
            email=email,
            unclassified=unclassified,
        )

        user_tips.additional_properties = d
        return user_tips

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
